/**********************************************************************
 *
 * z3950proto.h --
 * Copyright (C) 2000  The New Zealand Digital Library Project
 *
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *********************************************************************/

#ifndef Z3950PROTO_H
#define Z3950PROTO_H

#include "recptproto.h"

// each server can have one or more databases
/*
  class z3950_DB {
  protected:
  text_t name; // Descriptive name
  text_t database; // name for server
  
  public:
  z3950_DB();     // constructor
  ~z3950_DB();    // deconstructor
  const text_t getName() {return name;}                // this gets name
  void setName(text_t newName) {name=newName;} // this sets name
  // need to get next (for linked list)
  };
  

  typedef  vector<z3950_DB>  z3950_DB_array;
*/

/*class z3950_DB_Array {
  protected:
  int count;
  // some arraytype...
  public:
  z3950_DB first();
  z3950_DB last();
  void     add(z3950_DB *db);
  void     remove(z3950_DB *db);
  };
*/


class z3950_server {
 protected:
  text_t title;    // Descriptive name
  text_t hostname; // network name (IP or host+domain name)
  text_tmap meta;  // metadata for this collection (ie server/database pair)
  // this is currently only iconcollection (and iconcollectionsmall)
  int count;
  //  z3950_DB_array* db;
  ShortColInfo_t *info; // has  (database) name, host and port

 public:
  z3950_server();
  // z3950_DB_array getDBs();
  const text_t getName() {return title;}
  void setName(const text_t &newname) {title=newname;}
  //  void setHostname(const text_t &newname) {hostname=newname;}
  void setInfo(ShortColInfo_t *newinfo) {info=newinfo;}
  const ShortColInfo_t *getInfo() {return info;}
  const text_tmap *getMeta() {return &meta;}
};

typedef  vector<z3950_server>  z3950_server_array;




class z3950proto : public recptproto {
protected:
  int zserver_count;
  z3950_server_array zservers;
public:
  z3950proto();
  virtual ~z3950proto() {}

  /*
  void add_collectserver (collectserver *thecserver) 
        {cservers.addcollectserver(thecserver);}
  */

  void add_server(const z3950_server& zserver);

  void configure (const text_t &key, const text_tarray &cfgline);

  bool init (ostream &logout);

  text_t get_protocol_name () {return "z3950proto";}

  void get_collection_list (text_tarray &collist, comerror_t &err, 
			    ostream &logout);

  void has_collection (const text_t &collection, bool &hascollection, 
		       comerror_t &err, ostream &logout);
  
  void ping (const text_t &collection, bool &wassuccess, 
	     comerror_t &err, ostream &logout);
  
  void get_collectinfo (const text_t &collection, 
			ColInfoResponse_t &collectinfo,
			comerror_t &err, ostream &logout);
  
  void get_filterinfo (const text_t &collection,
		       InfoFiltersResponse_t &response,
		       comerror_t &err, ostream &logout);
  
  /*  void get_info (const text_t &collection, const text_tset &metadata,
      FilterResponse_t &response, ostream &logout);
  */
  
  void filter (const text_t &collection,
	       FilterRequest_t &request,
	       FilterResponse_t &response,
	       comerror_t &err, ostream &logout);
  
  void get_document (const text_t &collection,
		     const DocumentRequest_t &request,
		     DocumentResponse_t &response,
		     comerror_t &err, ostream &logout);

};


#endif
